'                                  /   \
'                          )      ((   ))     (
'( )                      /|\      ))_((     /|\
'|-|                     / | \    (/\|/\)   / | \                      ( )
'| |--------------------/--|-voV---\`|'/--Vov-|--\---------------------|-|
'|-|                         '^`   (o o)  '^`                          | |
'| |   X-GUI 4 source codes 1-1/2  `\Y/'      Kenneth Garin (coder)    |-|
'|-|                                          Joe Bardell (bugs/extra) | |
'| |   Compile EXE using SVGAPV.QLB           Stephen Balkum (svgapv)  |-|
'|-|                                          Daniel Sill (svgapv)     | |
'| |   Syntax- PDS 7.1 (or VBDOS)             HTTP://WWW.XGUI.NET      |-|
'|_|___________________________________________________________________| |
'( )              l   /\ /         ( (       \ /\   l                `\|-|
'                 l /   V           \ \       V   \ l                  ( )
'                 l/                _) )_          \I
'                                   `\ /'
'

DECLARE FUNCTION getvar$ (varname$, pid!)
DECLARE FUNCTION readline$ (linenumber%, pid!)
DECLARE FUNCTION window.create! (X1!, Y1!, X2!, Y2!, closebtn!, resizebtn!, movebtn!, title$)
DECLARE SUB setuppointers (mousefile$, mousefile2$)
DECLARE SUB PANIC (message$)
DECLARE SUB background (wallpaper$)
DECLARE SUB fontnormal ()
DECLARE SUB fontload (FileName$)
DECLARE SUB startscript (FileName$, cmd$)
DECLARE SUB putvar (varname$, contents$, pid!)
DECLARE SUB drw3Dbox (X1%, Y1%, X2%, Y2%, col1%, col2%)
DECLARE SUB hidegraph (truth%)
DECLARE SUB screen.close ()
DECLARE SUB screen.setup ()
DECLARE SUB window.close (id%)
DECLARE SUB window.manager ()
DECLARE SUB window.paint (X1%, Y1%, X2%, Y2%, closebtn%, resizebtn%, movebtn%, title$, active%)
DECLARE SUB winvput (id!)
DECLARE SUB winvsave (id!)
DECLARE SUB setpoi (FileName$, v$)
DECLARE SUB timerset (truth%)
DECLARE SUB startup ()
DECLARE SUB scrshot ()
DECLARE SUB chactcol (newcol!)
DECLARE SUB chnonactcol (newcol!)
DECLARE SUB chbcolor (newcol!)
DECLARE SUB chwallpaper (newfile$)

'$INCLUDE: 'SVGABC.BI'

CONST true = 1, false = 0       ' real logic
CONST maxwins = 30              ' always +2 more then actual value
CONST stfile$ = "SHELL.XSF"     ' first ran script file

DIM SHARED pcxpal AS STRING * 768, refreshwindows
DIM SHARED maxx, maxy
DIM SHARED mx%, my%, mb%, bgcolor, openwins
DIM SHARED actcolor, nonactcolor, titlecolor
DIM SHARED bghandle%, crhandle%
DIM SHARED mainmem$(1 TO maxwins), IP(1 TO maxwins) AS INTEGER
DIM SHARED vtx%(1 TO maxwins), vty%(1 TO maxwins)
DIM SHARED flags1%(1 TO maxwins), flags2%(1 TO maxwins), flags3%(1 TO maxwins)
DIM SHARED co1%(1 TO maxwins), co2%(1 TO maxwins)
DIM SHARED pstack$(1 TO maxwins)
DIM SHARED pcommand$(1 TO maxwins), pfiles$(1 TO maxwins)
DIM SHARED homedir$, derror(1 TO maxwins)
DIM SHARED sfonx%, sfony%, sfon$, fon AS STRING * 4098
DIM SHARED repair, switch

TYPE windows
 objectID AS INTEGER            ' ID of window environment
 X1 AS INTEGER                  ' windows x1
 Y1 AS INTEGER                  ' windows y1
 X2 AS INTEGER                  ' windows x2
 Y2 AS INTEGER                  ' windows y2
 closebtn AS INTEGER            ' window close button truth
 resizebtn AS INTEGER           ' window resize button truth
 movebtn AS INTEGER             ' window titlebar show truth
 title AS STRING * 60           ' window title
 virtual AS INTEGER             ' window virtual screen pointer to XMS
END TYPE

DIM SHARED win(1 TO maxwins) AS windows

startup
START: CLEAR

homedir$ = CURDIR$
switch = true

ON ERROR GOTO errhandler

screen.setup

IF DIR$(stfile$) <> "" THEN
 startscript stfile$, ""
 ELSE
 PANIC stfile$ + " main script not found."
END IF

DO
 MOUSESTATUS x%, y%, b%
 scrshot
 window.manager
 IF refreshwindows = false AND openwins <> false THEN
  activewin = win(openwins).objectID
  X1 = win(openwins).X1 + 2: Y1 = win(openwins).Y1 + 2
  X2 = win(openwins).X2 - 2: Y2 = win(openwins).Y2 - 2
  IF win(openwins).movebtn THEN Y1 = Y1 + 18
  IF win(openwins).resizebtn THEN X2 = X2 - 19: Y2 = Y2 - 19
  a$ = readline$(IP(activewin), activewin)
  derror = false
  IF a$ = "R" THEN
   p$ = pstack$(activewin)
   DO
    IF INSTR(p$, ".") = false THEN EXIT DO
    p$ = MID$(p$, INSTR(p$, ".") + 1)
   LOOP
   pstack$(activewin) = LEFT$(pstack$(activewin), LEN(pstack$(activewin)) - LEN(p$) - 1)
   IP(activewin) = VAL(p$)
  END IF
  IF LEFT$(a$, 1) = CHR$(1) THEN
   p$ = LTRIM$(MID$(a$, 2))
   pstack$(activewin) = pstack$(activewin) + "." + LTRIM$(STR$(IP(activewin)))
   label$ = UCASE$(p$): GOTO jump
  END IF
  IF LEFT$(a$, 1) = ">" THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF RIGHT$(p$, 1) = "$" THEN p$ = getvar$(p$, activewin)
   IF LEFT$(p$, 1) = CHR$(34) THEN p$ = MID$(p$, 2): p$ = LEFT$(p$, LEN(p$) - 1)
   MOUSEHIDE
   h% = XMSSCREENGET%
   OUT 968, 66
   SHELL p$
   OUT 968, 0
   e% = XMSSCREENPUT%(h%)
   e% = XMSFREE%(h%)
   MOUSESHOW
  END IF
  IF LEFT$(a$, 1) = "!" THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF RIGHT$(p$, 1) = "$" OR RIGHT$(p$, 1) = "%" THEN p$ = getvar$(p$, activewin)
   IF LEFT$(p$, 1) = CHR$(34) THEN p$ = MID$(p$, 2): p$ = LEFT$(p$, LEN(p$) - 1)
   PANIC p$
  END IF
  IF LEFT$(a$, 1) = "@" THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a4$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a1$, 1) = "%" THEN a1$ = getvar$(a1$, activewin)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   IF RIGHT$(a4$, 1) = "%" THEN a4$ = getvar$(a4$, activewin)
   MOUSEHIDE
   SETVIEW X1, Y1, X2, Y2
   winvsave openwins
   SETVIEW 0, 0, maxx, maxy
   dummy% = XMSBLKPUT%(1, 0, 0, crhandle%)
   MOUSESHOW
   win(openwins).X1 = VAL(a1$): win(openwins).Y1 = VAL(a2$)
   win(openwins).X2 = VAL(a3$): win(openwins).Y2 = VAL(a4$)
   IF win(openwins).X2 > maxx THEN win(openwins).X2 = maxx
   IF win(openwins).Y2 > maxy THEN win(openwins).Y2 = maxy
   refreshwindows = true
   repair = true
  END IF
  IF a$ = "S-" THEN switch = false
  IF a$ = "S+" THEN switch = true
  IF LEFT$(a$, 1) = "`" THEN
   p$ = LTRIM$(MID$(a$, 2))
   putvar p$, STR$(repair), activewin
   repair = false
  END IF
  IF LEFT$(a$, 1) = "c" THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF RIGHT$(p$, 1) = "%" THEN p$ = getvar$(p$, activewin)
   bgcolor = VAL(p$)
   chbcolor bgcolor
   refreshwindows = true
   repair = true
  END IF
  IF LEFT$(a$, 1) = "n" THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF RIGHT$(p$, 1) = "%" THEN p$ = getvar$(p$, activewin)
   nonactcolor = VAL(p$)
   chnonactcol nonactcolor
   refreshwindows = true
   repair = true
  END IF
  IF LEFT$(a$, 1) = "a" THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF RIGHT$(p$, 1) = "%" THEN p$ = getvar$(p$, activewin)
   actcolor = VAL(p$)
   chactcol actcolor
   refreshwindows = true
   repair = true
  END IF
  IF LEFT$(a$, 1) = "\" THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF RIGHT$(p$, 1) = "$" THEN p$ = getvar$(p$, activewin)
   fontload p$
   sfon$ = p$
   FK = FREEFILE: KL = false
   OPEN "SETTINGS.INI" FOR INPUT AS FK
   FL = FREEFILE
   OPEN "SETTINGS.TMP" FOR OUTPUT AS FL
   DO UNTIL EOF(FK)
    LINE INPUT #FK, h$
    h$ = UCASE$(LTRIM$(h$))
    IF LEFT$(h$, 12) = "SYSTEM FONT " THEN
     PRINT #FL, "SYSTEM FONT " + p$: KL = true
     ELSE
     PRINT #FL, h$
    END IF
   LOOP
   IF KL = false THEN PRINT #FL, "SYSTEM FONT " + p$
   CLOSE FK, FL
   OPEN "SETTINGS.INI" FOR OUTPUT AS FK
   OPEN "SETTINGS.TMP" FOR INPUT AS FL
   DO UNTIL EOF(FL)
    LINE INPUT #FL, h$: PRINT #FK, h$
   LOOP
   CLOSE FK, FL
   KILL "SETTINGS.TMP"
   refreshwindows = true
   repair = true
  END IF
  IF LEFT$(a$, 1) = "t" THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF RIGHT$(p$, 1) = "%" THEN p$ = getvar$(p$, activewin)
   titlecolor = VAL(p$)
   FK = FREEFILE: KL = false
   OPEN "SETTINGS.INI" FOR INPUT AS FK
   FL = FREEFILE
   OPEN "SETTINGS.TMP" FOR OUTPUT AS FL
   DO UNTIL EOF(FK)
    LINE INPUT #FK, h$
    h$ = UCASE$(LTRIM$(h$))
    IF LEFT$(h$, 12) = "TITLE COLOR " THEN
     PRINT #FL, "TITLE COLOR " + p$: KL = true
     ELSE
     PRINT #FL, h$
    END IF
   LOOP
   IF KL = false THEN PRINT #FL, "TITLE COLOR " + p$
   CLOSE FK, FL
   OPEN "SETTINGS.INI" FOR OUTPUT AS FK
   OPEN "SETTINGS.TMP" FOR INPUT AS FL
   DO UNTIL EOF(FL)
    LINE INPUT #FL, h$: PRINT #FK, h$
   LOOP
   CLOSE FK, FL
   KILL "SETTINGS.TMP"
   refreshwindows = true
   repair = true
  END IF
  IF LEFT$(a$, 1) = "b" THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF RIGHT$(p$, 1) = "$" THEN p$ = getvar$(p$, activewin)
   IF LEFT$(p$, 1) = CHR$(34) THEN p$ = MID$(p$, 2): p$ = LEFT$(p$, LEN(p$) - 1)
   background p$ + "~"
   chwallpaper p$
  END IF
  IF LEFT$(a$, 1) = "#" THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF RIGHT$(p$, 1) = "$" OR RIGHT$(p$, 1) = "%" THEN p$ = getvar$(p$, activewin)
   IF LEFT$(p$, 1) = CHR$(34) THEN p$ = MID$(p$, 2): p$ = LEFT$(p$, LEN(p$) - 1)
   win(openwins).title = p$
   MOUSEHIDE
   window.paint win(openwins).X1, win(openwins).Y1, win(openwins).X2, win(openwins).Y2, win(openwins).closebtn, win(openwins).resizebtn, win(openwins).movebtn, CHR$(3) + p$, true
   MOUSESHOW
  END IF
  IF LEFT$(a$, 3) = "GP " THEN
   p$ = LTRIM$(MID$(a$, 4)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a3$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   putvar a1$, STR$(GETPOINT%(VAL(a2$) + X1, VAL(a3$) + Y1)), activewin
  END IF
  IF LEFT$(a$, 3) = "FA " THEN
   p$ = LTRIM$(MID$(a$, 4)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a4$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a1$, 1) = "%" THEN a1$ = getvar$(a1$, activewin)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   IF RIGHT$(a4$, 1) = "%" THEN a4$ = getvar$(a4$, activewin)
   SETVIEW X1, Y1, X2, Y2
   FILLAREA VAL(a1$) + X1, VAL(a2$) + Y1, VAL(a3$), VAL(a4$)
   SETVIEW 0, 0, maxx, maxy
  END IF
  IF LEFT$(a$, 3) = "HD " THEN putvar LTRIM$(MID$(a$, 4)), homedir$, activewin
  IF LEFT$(a$, 3) = "OP " THEN
   p$ = LTRIM$(MID$(a$, 4))
   IF RIGHT$(p$, 1) = "$" THEN p$ = getvar$(p$, activewin)
   IF LEFT$(p$, 1) = CHR$(34) THEN p$ = MID$(p$, 2): p$ = LEFT$(p$, LEN(p$) - 1)
   FF = FREEFILE
   OPEN p$ FOR OUTPUT AS FF
   FOR R = 1 TO maxwins - 1
    IF win(R).objectID <> false THEN PRINT #FF, RTRIM$(win(R).title) + " " + STR$(win(R).objectID) + CHR$(13)
   NEXT
   CLOSE FF
  END IF
  IF LEFT$(a$, 3) = "XF " THEN
   p$ = LTRIM$(MID$(a$, 4))
   IF RIGHT$(p$, 1) = "%" THEN p$ = getvar$(p$, activewin)
   dummy% = XMSFREE%(VAL(p$))
  END IF
  IF LEFT$(a$, 3) = "XP " THEN
   p$ = LTRIM$(MID$(a$, 4)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a4$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a1$, 1) = "%" THEN a1$ = getvar$(a1$, activewin)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   a4$ = getvar$(a4$, activewin)
   SETVIEW X1, Y1, X2, Y2
   dummy% = XMSBLKPUT%(VAL(a3$), VAL(a1$) + X1, VAL(a2$) + Y1, VAL(a4$))
   SETVIEW 0, 0, maxx, maxy
  END IF
  IF LEFT$(a$, 3) = "XG " THEN
   p$ = LTRIM$(MID$(a$, 4)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a4$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a5$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   IF RIGHT$(a4$, 1) = "%" THEN a4$ = getvar$(a4$, activewin)
   IF RIGHT$(a5$, 1) = "%" THEN a5$ = getvar$(a5$, activewin)
   putvar a1$, STR$(XMSBLKGET%(VAL(a2$) + X1, VAL(a3$) + Y1, VAL(a4$) + X1, VAL(a5$) + Y1)), activewin
  END IF
  IF LEFT$(a$, 4) = "_GC " THEN
   p$ = LTRIM$(MID$(a$, 5))
   putvar p$, pcommand$(activewin), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(43) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a3$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a1$, 1) = "%" THEN a1$ = getvar$(a1$, activewin)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   DEF SEG = VAL(a1$)
    POKE VAL(a2$), VAL(a3$)
   DEF SEG
  END IF
  IF LEFT$(a$, 1) = CHR$(45) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a3$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   DEF SEG = VAL(a2$)
    putvar a1$, STR$(PEEK(VAL(a3$))), activewin
   DEF SEG
  END IF
  IF LEFT$(a$, 1) = CHR$(202) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a3$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a2$, 1) = "$" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "$" THEN a3$ = getvar$(a3$, activewin)
   IF LEFT$(a3$, 1) = CHR$(34) THEN a3$ = MID$(a3$, 2): a3$ = LEFT$(a3$, LEN(a3$) - 1)
   putvar a1$, STR$(INSTR(a2$, a3$)), activewin
  END IF
  IF LEFT$(a$, 4) = "POI " THEN
   p$ = LTRIM$(MID$(a$, 5))
   IF RIGHT$(p$, 1) = "$" THEN p$ = getvar$(p$, activewin)
   IF LEFT$(p$, 1) = CHR$(34) THEN p$ = MID$(p$, 2): p$ = LEFT$(p$, LEN(p$) - 1)
   setpoi p$, mousepointer$
  END IF
  IF LEFT$(a$, 4) = "DIR " THEN
   p$ = LTRIM$(MID$(a$, 5))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(d$, 1) = "$" THEN d$ = getvar$(d$, activewin)
   IF RIGHT$(s$, 1) = "$" THEN s$ = getvar$(s$, activewin)
   IF LEFT$(d$, 1) = CHR$(34) THEN d$ = MID$(d$, 2): d$ = LEFT$(d$, LEN(d$) - 1)
   IF LEFT$(s$, 1) = CHR$(34) THEN s$ = MID$(s$, 2): s$ = LEFT$(s$, LEN(s$) - 1)
   FF = FREEFILE
   OPEN d$ FOR OUTPUT AS FF
   f$ = DIR$(s$)
   PRINT #FF, f$
   DO UNTIL f$ = ""
    f$ = DIR$
    PRINT #FF, f$
   LOOP
   CLOSE FF
  END IF
  IF LEFT$(a$, 4) = "PID " THEN
   p$ = LTRIM$(MID$(a$, 5))
   putvar p$, STR$(activewin), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(201) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   putvar d$, STR$(VAL(s$)), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(253) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   putvar d$, STR$(sfonx%), activewin
   putvar s$, STR$(sfony%), activewin
  END IF
  IF LEFT$(a$, 1) = "{" THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   putvar d$, STR$(maxx), activewin
   putvar s$, STR$(maxy), activewin
  END IF
  IF LEFT$(a$, 4) = "EOF " THEN
   p$ = LTRIM$(MID$(a$, 5))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   putvar d$, STR$(EOF(VAL(s$))), activewin
  END IF
  IF LEFT$(a$, 4) = "LOF " THEN
   p$ = LTRIM$(MID$(a$, 5))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   putvar d$, STR$(LOF(VAL(s$))), activewin
  END IF
  IF LEFT$(a$, 3) = "FP " THEN
   p$ = LTRIM$(MID$(a$, 4))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(d$, 1) = "%" THEN d$ = getvar$(d$, activewin)
   IF LEFT$(s$, 1) = CHR$(34) THEN s$ = MID$(s$, 2): s$ = LEFT$(s$, LEN(s$) - 1)
   PUT #VAL(d$), , s$
  END IF
  IF LEFT$(a$, 3) = "FG " THEN
   p$ = LTRIM$(MID$(a$, 4))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   GET #VAL(s$), , f$
   putvar d$, f$, activewin
  END IF
  IF LEFT$(a$, 3) = "FW " THEN
   p$ = LTRIM$(MID$(a$, 4))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(d$, 1) = "%" THEN d$ = getvar$(d$, activewin)
   IF RIGHT$(s$, 1) = "$" OR RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   IF LEFT$(s$, 1) = CHR$(34) THEN s$ = MID$(s$, 2): s$ = LEFT$(s$, LEN(s$) - 1)
   PRINT #VAL(d$), s$
  END IF
  IF LEFT$(a$, 3) = "FI " THEN
   p$ = LTRIM$(MID$(a$, 4))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   LINE INPUT #VAL(s$), f$
   putvar d$, f$, activewin
  END IF
  IF LEFT$(a$, 1) = "Z" THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   IF RIGHT$(d$, 1) = "%" THEN d$ = getvar$(d$, activewin)
   IF VAL(d$) > 0 THEN
    FOR dummy = 1 TO VAL(d$)
     LINE INPUT #VAL(s$), dummy$
     IF EOF(VAL(s$)) THEN EXIT FOR
    NEXT
   END IF
  END IF
  IF LEFT$(a$, 3) = "FH " THEN putvar LTRIM$(MID$(a$, 4)), STR$(FREEFILE), activewin
  IF LEFT$(a$, 3) = "CL " THEN
   p$ = LTRIM$(MID$(a$, 4))
   IF RIGHT$(p$, 1) = "%" THEN p$ = getvar$(p$, activewin)
   f = VAL(p$)
   FOR FF = 1 TO LEN(pfiles$(activewin))
    m$ = MID$(pfiles$(activewin), FF)
    IF pfiles$(activewin) <> "" THEN
     IF ASC(m$) = f THEN pfiles$(activewin) = LEFT$(pfiles$(activewin), FF - 1) + MID$(pfiles$(activewin), FF + 1)
    END IF
   NEXT
   CLOSE f
  END IF
  IF LEFT$(a$, 1) = "J" THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a4$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a5$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a6$ = MID$(p$, INSTR(p$, ",") + 1)
   JOYSTICKINFO jax%, jay%, jab%, jbx%, jby%, jbb%
   putvar a1$, STR$(jax%), activewin
   putvar a2$, STR$(jay%), activewin
   putvar a3$, STR$(jab%), activewin
   putvar a4$, STR$(jbx%), activewin
   putvar a5$, STR$(jby%), activewin
   putvar a6$, STR$(jbb%), activewin
  END IF
  IF LEFT$(a$, 2) = "O " THEN
   p$ = LTRIM$(MID$(a$, 3)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a3$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a1$, 1) = "$" THEN a1$ = getvar$(a1$, activewin)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   IF LEFT$(a1$, 1) = CHR$(34) THEN a1$ = MID$(a1$, 2): a1$ = LEFT$(a1$, LEN(a1$) - 1)
   SELECT CASE VAL(a2$)
    CASE 1: OPEN a1$ FOR INPUT AS VAL(a3$)
    CASE 2: OPEN a1$ FOR APPEND AS VAL(a3$)
    CASE 3: OPEN a1$ FOR OUTPUT AS VAL(a3$)
    CASE 4: OPEN a1$ FOR BINARY AS VAL(a3$)
    CASE 5: OPEN a1$ FOR RANDOM AS VAL(a3$)
   END SELECT
   pfiles$(activewin) = CHR$(VAL(a3$))
  END IF
  IF LEFT$(a$, 4) = "TMR " THEN putvar LTRIM$(MID$(a$, 5)), STR$(TIMER), activewin
  IF LEFT$(a$, 4) = "RAN " THEN
   p$ = LTRIM$(MID$(a$, 5))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   RANDOMIZE TIMER
   putvar d$, STR$(INT(RND * VAL(s$))), activewin
  END IF
  IF LEFT$(a$, 4) = "MOD " THEN
   p$ = LTRIM$(MID$(a$, 5)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a3$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   putvar a1$, STR$(VAL(a2$) MOD VAL(a3$)), activewin
  END IF
  IF LEFT$(a$, 4) = "OCT " THEN
   p$ = LTRIM$(MID$(a$, 5))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   putvar d$, OCT$(VAL(s$)), activewin
  END IF
  IF LEFT$(a$, 4) = "HEX " THEN
   p$ = LTRIM$(MID$(a$, 5))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   putvar d$, HEX$(VAL(s$)), activewin
  END IF
  IF LEFT$(a$, 4) = "ATN " THEN
   p$ = LTRIM$(MID$(a$, 5))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   putvar d$, STR$(ATN(VAL(s$))), activewin
  END IF
  IF LEFT$(a$, 4) = "TAN " THEN
   p$ = LTRIM$(MID$(a$, 5))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   putvar d$, STR$(TAN(VAL(s$))), activewin
  END IF
  IF LEFT$(a$, 4) = "SIN " THEN
   p$ = LTRIM$(MID$(a$, 5))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   putvar d$, STR$(SIN(VAL(s$))), activewin
  END IF
  IF LEFT$(a$, 4) = "COS " THEN
   p$ = LTRIM$(MID$(a$, 5))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   putvar d$, STR$(COS(VAL(s$))), activewin
  END IF
  IF LEFT$(a$, 4) = "ABS " THEN
   p$ = LTRIM$(MID$(a$, 5))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   putvar d$, STR$(ABS(VAL(s$))), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(204) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(d$, 1) = "%" THEN d$ = getvar$(d$, activewin)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   SOUND VAL(d$), VAL(s$)
  END IF
  IF LEFT$(a$, 1) = CHR$(203) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "$" THEN s$ = getvar$(s$, activewin)
   putvar d$, STR$(LEN(s$)), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(200) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "$" THEN s$ = getvar$(s$, activewin)
   putvar d$, LCASE$(s$), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(199) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "$" THEN s$ = getvar$(s$, activewin)
   putvar d$, UCASE$(s$), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(198) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a4$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a2$, 1) = "$" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   IF RIGHT$(a4$, 1) = "%" THEN a4$ = getvar$(a4$, activewin)
   IF VAL(a4$) <> false THEN g$ = MID$(a2$, VAL(a3$), VAL(a4$)) ELSE g$ = MID$(a2$, VAL(a3$))
   putvar a1$, g$, activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(197) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a3$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a2$, 1) = "$" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   putvar a1$, RIGHT$(a2$, VAL(a3$)), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(196) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a3$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a2$, 1) = "$" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   putvar a1$, LEFT$(a2$, VAL(a3$)), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(195) THEN putvar LTRIM$(MID$(a$, 2)), STR$(derror(activewin)), activewin: derror(activewin) = false
  IF LEFT$(a$, 1) = CHR$(194) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "$" THEN s$ = getvar$(s$, activewin)
   putvar d$, RTRIM$(LTRIM$(s$)), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(193) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "$" THEN s$ = getvar$(s$, activewin)
   putvar d$, RTRIM$(s$), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(192) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "$" THEN s$ = getvar$(s$, activewin)
   putvar d$, LTRIM$(s$), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(191) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   putvar d$, CHR$(VAL(s$)), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(190) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "$" THEN s$ = getvar$(s$, activewin)
   IF s$ <> "" THEN putvar d$, STR$(ASC(s$)), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(137) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(d$, 1) = "%" THEN d$ = getvar$(d$, activewin)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   OUT VAL(d$), VAL(s$)
  END IF
  IF LEFT$(a$, 1) = CHR$(138) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(d$, 1) = "%" THEN d$ = getvar$(d$, activewin)
   putvar s$, STR$(INP(VAL(d$))), activewin
  END IF
  IF a$ = "RES" THEN RES = true: EXIT DO
  IF a$ = "SYS" THEN EXIT DO
  IF LEFT$(a$, 1) = CHR$(136) THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF RIGHT$(p$, 1) = "$" THEN p$ = getvar$(p$, activewin)
   IF LEFT$(p$, 1) = CHR$(34) THEN p$ = MID$(p$, 2): p$ = LEFT$(p$, LEN(p$) - 1)
   DATE$ = p$
  END IF
  IF LEFT$(a$, 1) = CHR$(135) THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF RIGHT$(p$, 1) = "$" THEN p$ = getvar$(p$, activewin)
   IF LEFT$(p$, 1) = CHR$(34) THEN p$ = MID$(p$, 2): p$ = LEFT$(p$, LEN(p$) - 1)
   TIME$ = p$
  END IF
  IF LEFT$(a$, 1) = CHR$(134) THEN putvar LTRIM$(MID$(a$, 2)), DATE$, activewin
  IF LEFT$(a$, 1) = CHR$(133) THEN putvar LTRIM$(MID$(a$, 2)), TIME$, activewin
  IF LEFT$(a$, 1) = CHR$(182) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(d$, 1) = "$" THEN d$ = getvar$(d$, activewin)
   IF LEFT$(d$, 1) = CHR$(34) THEN d$ = MID$(d$, 2): d$ = LEFT$(d$, LEN(d$) - 1)
   IF DIR$(d$) <> "" THEN putvar s$, STR$(true), activewin ELSE putvar s$, STR$(false), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(181) THEN
   p$ = LTRIM$(MID$(a$, 2))
   putvar p$, CURDIR$, activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(180) THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF RIGHT$(p$, 1) = "$" THEN p$ = getvar$(p$, activewin)
   IF LEFT$(p$, 1) = CHR$(34) THEN p$ = MID$(p$, 2): p$ = LEFT$(p$, LEN(p$) - 1)
   CHDRIVE p$
   CHDIR p$
  END IF
  IF LEFT$(a$, 1) = CHR$(170) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(d$, 1) = "$" THEN d$ = getvar$(d$, activewin)
   IF RIGHT$(s$, 1) = "$" THEN s$ = getvar$(s$, activewin)
   IF LEFT$(d$, 1) = CHR$(34) THEN d$ = MID$(d$, 2): d$ = LEFT$(d$, LEN(d$) - 1)
   IF LEFT$(s$, 1) = CHR$(34) THEN s$ = MID$(s$, 2): s$ = LEFT$(s$, LEN(s$) - 1)
   IF INSTR(d$, ".") = false THEN d$ = d$ + ".XSF"
   IF d$ <> "" AND LEFT$(d$, 1) <> "." THEN
    IF DIR$(d$) <> "" THEN
     MOUSEHIDE
     winvsave openwins
     MOUSESHOW
     startscript d$, s$
     ELSE
     derror(activewin) = 53
    END IF
   END IF
  END IF
  IF LEFT$(a$, 1) = CHR$(171) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(d$, 1) = "$" THEN d$ = getvar$(d$, activewin)
   IF LEFT$(d$, 1) = CHR$(34) THEN d$ = MID$(d$, 2): d$ = LEFT$(d$, LEN(d$) - 1)
   RMDIR d$
   putvar s$, STR$(derror(activewin)), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(172) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(d$, 1) = "$" THEN d$ = getvar$(d$, activewin)
   IF LEFT$(d$, 1) = CHR$(34) THEN d$ = MID$(d$, 2): d$ = LEFT$(d$, LEN(d$) - 1)
   MKDIR d$
   putvar s$, STR$(derror(activewin)), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(165) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(d$, 1) = "$" THEN d$ = getvar$(d$, activewin)
   IF LEFT$(d$, 1) = CHR$(34) THEN d$ = MID$(d$, 2): d$ = LEFT$(d$, LEN(d$) - 1)
   KILL d$
   putvar s$, STR$(derror(activewin)), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(164) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a4$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a4$, 1) = "$" THEN a4$ = getvar$(a4$, activewin)
   IF LEFT$(a4$, 1) = CHR$(34) THEN a4$ = MID$(a4$, 2): a4$ = LEFT$(a4$, LEN(a4$) - 1)
   dummy% = PCXGETINFO%(a4$, x%, y%, cols%, pcxpal)
   putvar a1$, STR$(x%), activewin: putvar a2$, STR$(y%), activewin
   putvar a3$, STR$(cols%), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(163) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a4$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a5$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a1$, 1) = "%" THEN a1$ = getvar$(a1$, activewin)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   IF RIGHT$(a4$, 1) = "%" THEN a4$ = getvar$(a4$, activewin)
   IF RIGHT$(a5$, 1) = "$" THEN a5$ = getvar$(a5$, activewin)
   IF LEFT$(a5$, 1) = CHR$(34) THEN a5$ = MID$(a5$, 2): a5$ = LEFT$(a5$, LEN(a5$) - 1)
   MOUSEHIDE
   SETVIEW X1, Y1, X2, Y2
   dummy% = PCXMAKE%(VAL(a1$) + X1, VAL(a2$) + Y1, VAL(a3$) + X1, VAL(a4$) + Y1, a5$)
   SETVIEW 0, 0, maxx, maxy
   MOUSESHOW
  END IF
  IF LEFT$(a$, 1) = CHR$(162) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a4$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a1$, 1) = "%" THEN a1$ = getvar$(a1$, activewin)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "$" THEN a3$ = getvar$(a3$, activewin)
   IF RIGHT$(a4$, 1) = "%" THEN a4$ = getvar$(a4$, activewin)
   IF LEFT$(a3$, 1) = CHR$(34) THEN a3$ = MID$(a3$, 2): a3$ = LEFT$(a3$, LEN(a3$) - 1)
   MOUSEHIDE
   SETVIEW X1, Y1, X2, Y2
   dummy% = PCXPUT%(VAL(a4$), VAL(a1$) + X1, VAL(a2$) + Y1, a3$)
   SETVIEW 0, 0, maxx, maxy
   MOUSESHOW
  END IF
  IF LEFT$(a$, 1) = CHR$(161) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a4$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a5$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a1$, 1) = "%" THEN a1$ = getvar$(a1$, activewin)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   IF RIGHT$(a4$, 1) = "%" THEN a4$ = getvar$(a4$, activewin)
   IF RIGHT$(a5$, 1) = "%" THEN a5$ = getvar$(a5$, activewin)
   SETVIEW X1, Y1, X2, Y2
   DRWCIRCLE VAL(a4$), VAL(a5$), VAL(a1$) + X1, VAL(a2$) + Y1, VAL(a3$)
   SETVIEW 0, 0, maxx, maxy
  END IF
  IF LEFT$(a$, 1) = ")" THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a4$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a5$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a1$, 1) = "%" THEN a1$ = getvar$(a1$, activewin)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   IF RIGHT$(a4$, 1) = "%" THEN a4$ = getvar$(a4$, activewin)
   IF RIGHT$(a5$, 1) = "%" THEN a5$ = getvar$(a5$, activewin)
   SETVIEW X1, Y1, X2, Y2
   DRWFILLCIRCLE VAL(a4$), VAL(a5$), VAL(a1$) + X1, VAL(a2$) + Y1, VAL(a3$)
   SETVIEW 0, 0, maxx, maxy
  END IF
  IF a$ = CHR$(155) THEN MOUSEHIDE
  IF a$ = CHR$(156) THEN MOUSESHOW
  IF LEFT$(a$, 1) = CHR$(160) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a4$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a1$, 1) = "%" THEN a1$ = getvar$(a1$, activewin)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   IF RIGHT$(a4$, 1) = "%" THEN a4$ = getvar$(a4$, activewin)
   SETVIEW X1, Y1, X2, Y2
   DRWPOINT VAL(a3$), VAL(a4$), VAL(a1$) + X1, VAL(a2$) + Y1
   SETVIEW 0, 0, maxx, maxy
  END IF
  IF LEFT$(a$, 1) = CHR$(159) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a4$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a5$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a6$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a1$, 1) = "%" THEN a1$ = getvar$(a1$, activewin)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   IF RIGHT$(a4$, 1) = "%" THEN a4$ = getvar$(a4$, activewin)
   IF RIGHT$(a5$, 1) = "%" THEN a5$ = getvar$(a5$, activewin)
   IF RIGHT$(a6$, 1) = "%" THEN a6$ = getvar$(a6$, activewin)
   SETVIEW X1, Y1, X2, Y2
   DRWFILLBOX VAL(a5$), VAL(a6$), VAL(a1$) + X1, VAL(a2$) + Y1, VAL(a3$) + X1, VAL(a4$) + Y1
   SETVIEW 0, 0, maxx, maxy
  END IF
  IF LEFT$(a$, 1) = CHR$(158) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a4$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a5$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a6$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a1$, 1) = "%" THEN a1$ = getvar$(a1$, activewin)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   IF RIGHT$(a4$, 1) = "%" THEN a4$ = getvar$(a4$, activewin)
   IF RIGHT$(a5$, 1) = "%" THEN a5$ = getvar$(a5$, activewin)
   IF RIGHT$(a6$, 1) = "%" THEN a6$ = getvar$(a6$, activewin)
   SETVIEW X1, Y1, X2, Y2
   DRWBOX VAL(a5$), VAL(a6$), VAL(a1$) + X1, VAL(a2$) + Y1, VAL(a3$) + X1, VAL(a4$) + Y1
   SETVIEW 0, 0, maxx, maxy
  END IF
  IF LEFT$(a$, 1) = CHR$(157) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a4$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a5$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a6$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a1$, 1) = "%" THEN a1$ = getvar$(a1$, activewin)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   IF RIGHT$(a4$, 1) = "%" THEN a4$ = getvar$(a4$, activewin)
   IF RIGHT$(a5$, 1) = "%" THEN a5$ = getvar$(a5$, activewin)
   IF RIGHT$(a6$, 1) = "%" THEN a6$ = getvar$(a6$, activewin)
   SETVIEW X1, Y1, X2, Y2
   DRWLINE VAL(a5$), VAL(a6$), VAL(a1$) + X1, VAL(a2$) + Y1, VAL(a3$) + X1, VAL(a4$) + Y1
   SETVIEW 0, 0, maxx, maxy
  END IF
  IF LEFT$(a$, 3) = "WS " THEN
   p$ = LTRIM$(MID$(a$, 4))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   putvar d$, STR$(X2 - X1), activewin: putvar s$, STR$(Y2 - Y1), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(154) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a3$ = MID$(p$, INSTR(p$, ",") + 1)
   MOUSESTATUS x%, y%, b%: putvar a1$, STR$(x%), activewin
   putvar a2$, STR$(y%), activewin: putvar a3$, STR$(b%), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(153) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a3$ = MID$(p$, INSTR(p$, ",") + 1)
   MOUSESTATUS x%, y%, b%: putvar a1$, STR$(x% - X1), activewin
   putvar a2$, STR$(y% - Y1), activewin: putvar a3$, STR$(b%), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(20) THEN
   p$ = LTRIM$(MID$(a$, 2))
   putvar p$, STR$(FRE(-1)), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(152) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   putvar d$, STR$(vtx%(activewin)), activewin: putvar s$, STR$(vty%(activewin)), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(151) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(d$, 1) = "%" THEN d$ = getvar$(d$, activewin)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   vtx%(activewin) = VAL(d$): vty%(activewin) = VAL(s$)
  END IF
  IF LEFT$(a$, 1) = CHR$(132) THEN
   p$ = LTRIM$(MID$(a$, 2)): putvar p$, STR$(VAL(getvar$(p$, activewin)) - 1), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(131) THEN
   p$ = LTRIM$(MID$(a$, 2)): putvar p$, STR$(VAL(getvar$(p$, activewin)) + 1), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(17) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   putvar d$, STR$(FIX(VAL(getvar$(s$, activewin)))), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(143) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a3$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   putvar a1$, STR$(VAL(a2$) / VAL(a3$)), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(142) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a3$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a2$, 1) = "%" THEN a2$ = getvar$(a2$, activewin)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar$(a3$, activewin)
   putvar a1$, STR$(VAL(a2$) * VAL(a3$)), activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(141) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(d$, 1) = "%" THEN
    IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
    putvar d$, STR$(VAL(getvar$(d$, activewin)) - VAL(s$)), activewin
   END IF
  END IF
  IF LEFT$(a$, 1) = CHR$(140) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(d$, 1) = "%" THEN
    IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
    putvar d$, STR$(VAL(getvar$(d$, activewin)) + VAL(s$)), activewin
   END IF
   IF RIGHT$(d$, 1) = "$" THEN
    IF RIGHT$(s$, 1) = "$" THEN
     s$ = getvar$(s$, activewin)
     putvar d$, getvar$(d$, activewin) + s$, activewin
     ELSE
     IF LEFT$(s$, 1) = CHR$(34) THEN s$ = MID$(s$, 2): s$ = LEFT$(s$, LEN(s$) - 1)
     putvar d$, getvar$(d$, activewin) + s$, activewin
    END IF
   END IF
  END IF
  IF LEFT$(a$, 1) = CHR$(130) THEN
   p$ = LTRIM$(MID$(a$, 2)): a1$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a2$ = LEFT$(p$, INSTR(p$, ",") - 1)
   p$ = MID$(p$, INSTR(p$, ",") + 1): a3$ = LEFT$(p$, INSTR(p$, ",") - 1)
   a4$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(a1$, 1) = "$" THEN a1$ = getvar(a1$, activewin)
   IF RIGHT$(a1$, 1) = "%" THEN a1$ = LTRIM$(STR$(VAL(getvar(a1$, activewin))))
   IF LEFT$(a1$, 1) = CHR$(34) THEN a1$ = MID$(a1$, 2): a1$ = LEFT$(a1$, LEN(a1$) - 1)
   IF RIGHT$(a2$, 1) = "$" THEN a2$ = getvar(a2$, activewin)
   IF LEFT$(a2$, 1) = CHR$(34) THEN a2$ = MID$(a2$, 2): a2$ = LEFT$(a2$, LEN(a2$) - 1)
   IF RIGHT$(a3$, 1) = "%" THEN a3$ = getvar(a3$, activewin)
   IF RIGHT$(a4$, 1) = "%" THEN a4$ = getvar(a4$, activewin)
   t$ = UCASE$(LTRIM$(RTRIM$(a2$)))
   IF t$ <> "SYSTEM" THEN
    IF t$ <> "" THEN fontload a2$ ELSE FONTSYSTEM
   END IF
   MOUSEHIDE
   SETVIEW X1, Y1, X2, Y2
   DRWSTRING 1, co1%(activewin), co2%(activewin), a1$, X1 + VAL(a3$), Y1 + VAL(a4$)
   SETVIEW 0, 0, maxx, maxy
   MOUSESHOW
   IF t$ <> "SYSTEM" THEN
    fontnormal
   END IF
  END IF
  IF LEFT$(a$, 1) = CHR$(5) THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF flags2%(activewin) = 1 THEN label$ = UCASE$(p$): GOTO jump
  END IF
  IF LEFT$(a$, 1) = CHR$(6) THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF flags3%(activewin) = 1 THEN label$ = UCASE$(p$): GOTO jump
  END IF
  IF LEFT$(a$, 1) = CHR$(7) THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF flags2%(activewin) = 2 THEN label$ = UCASE$(p$): GOTO jump
  END IF
  IF LEFT$(a$, 1) = CHR$(11) THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF flags3%(activewin) = 2 THEN label$ = UCASE$(p$): GOTO jump
  END IF
  IF LEFT$(a$, 1) = CHR$(4) THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF flags1%(activewin) = 0 THEN label$ = UCASE$(p$): GOTO jump
  END IF
  IF LEFT$(a$, 1) = CHR$(3) THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF flags1%(activewin) = 1 OR flags1%(activewin) = 2 THEN label$ = UCASE$(p$): GOTO jump
  END IF
  IF LEFT$(a$, 1) = CHR$(144) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1)
   s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF LEFT$(d$, 1) = CHR$(34) THEN d$ = MID$(d$, 2): d$ = LEFT$(d$, LEN(d$) - 1)
   IF LEFT$(s$, 1) = CHR$(34) THEN s$ = MID$(s$, 2): s$ = LEFT$(s$, LEN(s$) - 1)
   IF RIGHT$(d$, 1) = "%" THEN d$ = getvar$(d$, activewin): s = false
   IF RIGHT$(d$, 1) = "$" THEN d$ = getvar$(d$, activewin): s = true
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar$(s$, activewin)
   IF RIGHT$(s$, 1) = "$" THEN s$ = getvar$(s$, activewin)
   flags1%(activewin) = false
   IF s = true THEN
    IF s$ = d$ THEN flags1%(activewin) = 1
    ELSE
    IF VAL(s$) = VAL(d$) THEN flags1%(activewin) = 2
   END IF
   flags2%(activewin) = false
   IF VAL(d$) > VAL(s$) THEN flags2%(activewin) = 1
   IF VAL(d$) < VAL(s$) THEN flags2%(activewin) = 2
   flags3%(activewin) = false
   IF VAL(d$) >= VAL(s$) THEN flags3%(activewin) = 1
   IF VAL(d$) <= VAL(s$) THEN flags3%(activewin) = 2
  END IF
  IF LEFT$(a$, 1) = CHR$(150) THEN
   p$ = LTRIM$(MID$(a$, 2))
   putvar p$, INKEY$, activewin
  END IF
  IF LEFT$(a$, 1) = CHR$(14) THEN
   p$ = LTRIM$(MID$(a$, 2))
   IF RIGHT$(p$, 1) = "%" THEN p$ = getvar$(p$, activewin)
   IF RIGHT$(p$, 1) = "$" THEN p$ = STR$(ASC(getvar$(p$, activewin)))
   p$ = CHR$(VAL(p$))
   GOSUB printf
  END IF
  IF LEFT$(a$, 1) = CHR$(12) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = MID$(p$, INSTR(p$, ",") + 1)
   IF RIGHT$(s$, 1) = "%" THEN s$ = getvar(s$, activewin)
   IF RIGHT$(d$, 1) = "%" THEN d$ = getvar(d$, activewin)
   co1%(activewin) = VAL(d$): co2%(activewin) = VAL(s$)
  END IF
  IF LEFT$(a$, 1) = CHR$(128) THEN
   p$ = LTRIM$(MID$(a$, 2))
   d$ = LEFT$(p$, INSTR(p$, ",") - 1): s$ = RTRIM$(MID$(p$, INSTR(p$, ",") + 1))
   IF RIGHT$(s$, 1) = "$" OR RIGHT$(s$, 1) = "%" THEN s$ = getvar(s$, activewin)
   putvar d$, s$, activewin
  END IF
  IF LEFT$(a$, 1) = "L" THEN
   p$ = LTRIM$(MID$(a$, 2))
   k = false
   IF RIGHT$(p$, 1) = ";" THEN
    k = true
    p$ = RTRIM$(LEFT$(p$, LEN(p$) - 1))
   END IF
   IF RIGHT$(p$, 1) = "$" THEN p$ = getvar(p$, activewin)
   IF RIGHT$(p$, 1) = "%" THEN p$ = LTRIM$(STR$(VAL(getvar(p$, activewin))))
   IF LEFT$(p$, 1) = CHR$(34) THEN p$ = MID$(p$, 2): p$ = LEFT$(p$, LEN(p$) - 1)
   IF p$ <> "" THEN
    IF k = true THEN LPRINT p$;  ELSE LPRINT p$
   END IF
  END IF
  IF LEFT$(a$, 1) = CHR$(129) THEN
   p$ = LTRIM$(MID$(a$, 2))
   k = false
   IF RIGHT$(p$, 1) = ";" THEN
    k = true
    p$ = RTRIM$(LEFT$(p$, LEN(p$) - 1))
   END IF
   IF RIGHT$(p$, 1) = "$" THEN p$ = getvar(p$, activewin)
   IF RIGHT$(p$, 1) = "%" THEN p$ = LTRIM$(STR$(VAL(getvar(p$, activewin))))
   IF LEFT$(p$, 1) = CHR$(34) THEN p$ = MID$(p$, 2): p$ = LEFT$(p$, LEN(p$) - 1)
   IF p$ <> "" THEN
    GOSUB printf
    IF k = false THEN p$ = CHR$(13): GOSUB printf
   END IF
  END IF
  IF LEFT$(a$, 1) = CHR$(2) THEN
   label$ = UCASE$(MID$(a$, 2))
jump:
   IP(activewin) = VAL(label$) - 2
  END IF
done:
  IF a$ <> "E" THEN
   IP(activewin) = IP(activewin) + 1
   ELSE
   window.close openwins + 0
  END IF
 END IF
LOOP
screen.close
IF RES = true THEN GOTO START
SYSTEM

printf:  ' print text into window as if it was a text mode screen
 MOUSEHIDE
 FOR Z = 1 TO LEN(p$)
  q$ = MID$(p$, Z, 1)
  IF q$ = CHR$(7) THEN
   SOUND 500, 1
   ELSE
   IF q$ = CHR$(13) THEN
    vty%(activewin) = vty%(activewin) + 1
    vtx%(activewin) = 0
    IF sfony% + 1 + vty%(activewin) * sfony% > Y2 - Y1 THEN GOSUB scrollf: vty%(activewin) = vty%(activewin) - 1
    ELSE
    IF q$ = CHR$(8) THEN
     IF vtx%(activewin) THEN
      vtx%(activewin) = vtx%(activewin) - 1
      x% = X1 + vtx%(activewin) * sfonx%: y% = Y1 + vty%(activewin) * sfony%
      DRWSTRING 1, co1%(activewin), co2%(activewin), " ", x%, y%
     END IF
     ELSE
     IF sfonx% + vtx%(activewin) * sfonx% > X2 - X1 THEN
      vty%(activewin) = vty%(activewin) + 1
      vtx%(activewin) = 0
      IF sfony% + 1 + vty%(activewin) * sfony% > Y2 - Y1 THEN GOSUB scrollf: vty%(activewin) = vty%(activewin) - 1
     END IF
     IF sfonx% + vtx%(activewin) * sfonx% > X2 - X1 THEN vtx%(activewin) = 0
     IF sfony% + 1 + vty%(activewin) * sfony% > Y2 - Y1 THEN vty%(activewin) = 0
     x% = X1 + vtx%(activewin) * sfonx%: y% = Y1 + vty%(activewin) * sfony%
     DRWSTRING 1, co1%(activewin), co2%(activewin), q$, x%, y%
     vtx%(activewin) = vtx%(activewin) + 1
    END IF
   END IF
  END IF
 NEXT
 MOUSESHOW
RETURN

scrollf:  ' scroll text in window
 scroll% = XMSBLKGET%(X1, Y1 + sfony%, X2, Y2)
 dummy% = XMSBLKPUT%(1, X1, Y1, scroll%)
 DRWFILLBOX 1, co2%(activewin), X1, Y2 - sfony%, X2, Y2
 dummy% = XMSFREE%(scroll%)
RETURN

errhandler:
 derror(activewin) = ERR
RESUME NEXT

REM I had way too much caffeine while programming this, hahahaha!!!

SUB background (wallpaper$)
IF RIGHT$(wallpaper$, 1) = "~" THEN
 wallpaper$ = LEFT$(wallpaper$, LEN(wallpaper$) - 1)
 mm = true
END IF
IF mm = true THEN timerset true
refreshwindows = true
IF mm = true THEN MOUSEHIDE
IF openwins THEN winvsave openwins
FILLSCREEN bgcolor
IF mm = true THEN MOUSESHOW
IF wallpaper$ <> "" THEN
 IF DIR$(wallpaper$) <> "" THEN
redo3:
  IF mm = true THEN MOUSEHIDE
  a% = PCXPUT%(1, xx%, yy%, wallpaper$)
  IF mm = true THEN MOUSESHOW
  a% = PCXGETINFO%(wallpaper$, x%, y%, ncols%, pcxpal)
  IF x% + xx% < maxx THEN xx% = xx% + x%: GOTO redo3 ELSE xx% = 0
  IF y% + yy% < maxy THEN yy% = yy% + y%: GOTO redo3 ELSE yy% = 0
 END IF
END IF
IF bghandle% <> false THEN dummy% = XMSFREE%(bghandle%)
IF mm = true THEN MOUSEHIDE
bghandle% = XMSBLKGET%(0, 0, maxx, maxy)
IF mm = true THEN
 MOUSESHOW
 timerset false
END IF
END SUB

SUB fontload (FileName$)
IF DIR$(FileName$) = "" THEN EXIT SUB
FF = FREEFILE: OPEN FileName$ FOR BINARY AS FF
GET #FF, , fon
CLOSE FF
FONTSET fon
END SUB

SUB fontnormal
IF sfon$ <> "" THEN fontload sfon$ ELSE FONTSYSTEM
END SUB

FUNCTION getvar$ (varname$, pid)
a$ = mainmem$(pid)
a = INSTR(UCASE$(a$), CHR$(127) + UCASE$(varname$))
IF a > false THEN
 b$ = MID$(a$, a)
 b$ = MID$(b$, INSTR(b$, ",") + 1)
 b$ = LTRIM$(RTRIM$(LEFT$(b$, INSTR(b$, CHR$(255)) - 1)))
 IF LEFT$(b$, 1) = CHR$(34) THEN b$ = MID$(b$, 2): b$ = LEFT$(b$, LEN(b$) - 1)
 getvar$ = b$
END IF
END FUNCTION

SUB putvar (varname$, contents$, pid)
varname$ = CHR$(127) + LTRIM$(RTRIM$(UCASE$(varname$)))
a$ = mainmem$(pid)
IF RIGHT$(varname$, 1) = "$" AND LEFT$(contents$, 1) <> CHR$(34) THEN contents$ = CHR$(34) + contents$ + CHR$(34)
a = INSTR(UCASE$(a$), varname$)
IF a > false THEN
 b$ = LEFT$(a$, a - 1) + varname$ + "," + contents$
 b$ = b$ + MID$(a$, INSTR(a, a$, CHR$(255)))
 mainmem$(pid) = b$
END IF
END SUB

FUNCTION readline$ (linenumber%, pid)
a$ = mainmem$(pid)
b$ = MID$(a$, INSTR(a$, CHR$(255) + LTRIM$(STR$(linenumber%)) + CHR$(252)))
b$ = MID$(b$, INSTR(b$, CHR$(252)) + 1)
readline$ = LEFT$(b$, INSTR(b$, CHR$(255)) - 1)
END FUNCTION

SUB screen.close
FOR i% = 1 TO maxwins
 window.close i%
NEXT
dummy% = XMSFREE%(bghandle%)
tmp% = RESTEXT%: CLS
END SUB

SUB screen.setup
freehandle = FREEFILE

bgcolor = 25

IF WHICHXMS(MEM%, handles%) = true THEN
 IF MEM% < 1 OR handles% < 1 THEN
  PANIC "no free XMS memory"
 END IF
 ELSE
 PANIC "HIMEM.SYS must be loaded first"
END IF

IF DIR$("SETTINGS.INI") <> "" THEN
 OPEN "SETTINGS.INI" FOR INPUT AS freehandle
 DO UNTIL EOF(freehandle)
  LINE INPUT #freehandle, settings$
  settings$ = LTRIM$(RTRIM$(UCASE$(settings$)))
  IF LEFT$(settings$, 4) = "MODE" THEN Mode$ = LTRIM$(MID$(settings$, 5))
  IF LEFT$(settings$, 14) = "MOUSE POINTER " THEN
   mousefile$ = MID$(settings$, 15)
  END IF
  IF LEFT$(settings$, 12) = "MOUSE TIMER " THEN
   mousefile2$ = MID$(settings$, 13)
  END IF
  IF LEFT$(settings$, 17) = "BACKGROUND COLOR " THEN bgcolor = VAL(MID$(settings$, 18))
  IF LEFT$(settings$, 13) = "ACTIVE COLOR " THEN actcolor = VAL(MID$(settings$, 14))
  IF LEFT$(settings$, 13) = "NONACT COLOR " THEN nonactcolor = VAL(MID$(settings$, 14))
  IF LEFT$(settings$, 12) = "TITLE COLOR " THEN titlecolor = VAL(MID$(settings$, 13))
  IF LEFT$(settings$, 10) = "WALLPAPER " THEN wallpaper$ = MID$(settings$, 11)
  IF LEFT$(settings$, 12) = "SYSTEM FONT " THEN sfon$ = MID$(settings$, 13)
 LOOP
 CLOSE freehandle
 ELSE
 Mode$ = "640X480"
 mousefile$ = "mouse.poi"
END IF

setuppointers mousefile$, mousefile2$

cardtype = WHICHVGA
IF WHICHMOUSE = false THEN
 PANIC "No mouse driver found"
END IF

SELECT CASE Mode$
 CASE "640X400": errorcheck = RES640L: maxx = 639: maxy = 399
 CASE "640X480": errorcheck = RES640: maxx = 639: maxy = 479
 CASE "800X600": errorcheck = RES800: maxx = 799: maxy = 599
 CASE "1024X768": errorcheck = RES1024: maxx = 1023: maxy = 767
 CASE "1280X1024": errorcheck = RES1280: maxx = 1279: maxy = 1023
END SELECT
IF errorcheck = false THEN
 PANIC "Video card can't use this screen mode in SETTINGS.INI"
END IF

dummy% = PAGEACTIVE%(1)
FILLPAGE 24
f$ = "XGUI4.INI"
a% = PCXGETINFO%(f$, xe%, ye%, ncols%, pcxpal)
xe% = xe% / 2: ye% = ye% / 2
a% = PCXPUT%(1, -xe% + maxx / 2, -ye% + maxy / 2, f$)
t$ = RIGHT$(TIME$, 2)
dummy% = PAGEACTIVE%(0)
dummy% = PAGEDISPLAY%(0, 0, 1)

background wallpaper$

FONTSYSTEM

IF sfon$ <> "" THEN
 IF DIR$(sfon$) <> "" THEN
  fontload sfon$
 END IF
END IF
FONTGETINFO sfonx%, sfony%

IF VAL(RIGHT$(TIME$, 2)) < VAL(t$) + 3 THEN SLEEP 2
dummy% = PAGEDISPLAY%(0, 0, 0)

MOUSEENTER
MOUSELOCSET 16, 16
timerset true
MOUSESHOW

END SUB

SUB startscript (FileName$, cmd$)
ON LOCAL ERROR GOTO sse
timerset true
FF = FREEFILE: OPEN FileName$ FOR INPUT AS FF
INPUT #FF, X1, Y1, X2, Y2, closebtn, resizebtn, movebtn, title$
process = window.create(X1, Y1, X2, Y2, closebtn, resizebtn, movebtn, title$)
DO UNTIL EOF(FF)
 LINE INPUT #FF, a$
 a$ = LTRIM$(RTRIM$(a$))
 l = l + 1
 mainmem$(process) = mainmem$(process) + CHR$(255) + LTRIM$(STR$(l)) + CHR$(252) + a$
LOOP
mainmem$(process) = mainmem$(process) + CHR$(255)
CLOSE FF
IP(process) = 1   'set instruction pointer to first line...
vtx%(process) = 0 'set virtual text cursor x
vty%(process) = 0 'set virtual text cursor y
co1%(process) = 0 'set color x, to 0
co2%(process) = 7 'set color ,x to 7
pcommand$(process) = cmd$
timerset false
EXIT SUB
sse:
RESUME ssee
ssee:
timerset false
END SUB

SUB window.close (id%)
IF win(id%).objectID = false THEN EXIT SUB
mainmem$(win(id%).objectID) = ""
a$ = pfiles$(win(id%).objectID)
IF a$ <> "" THEN
 FOR i = 1 TO LEN(a$)
  m$ = MID$(a$, i, 1)
  IF m$ <> "" THEN CLOSE ASC(m$)
 NEXT
END IF
pfiles$(win(id%).objectID) = ""
MOUSEHIDE
SETVIEW win(id%).X1, win(id%).Y1, win(id%).X2, win(id%).Y2
dummy% = XMSBLKPUT%(1, 0, 0, bghandle%)
SETVIEW 0, 0, maxx, maxy
MOUSESHOW
dummy% = XMSFREE%(win(id%).virtual)
FOR c = id% TO maxwins - 1  '*rollback* function #2
 win(c).X1 = win(c + 1).X1: win(c).Y1 = win(c + 1).Y1
 win(c).X2 = win(c + 1).X2: win(c).Y2 = win(c + 1).Y2
 win(c).closebtn = win(c + 1).closebtn: win(c).resizebtn = win(c + 1).resizebtn
 win(c).movebtn = win(c + 1).movebtn: win(c).title$ = win(c + 1).title$
 win(c).virtual = win(c + 1).virtual: win(c).objectID = win(c + 1).objectID
NEXT
openwins = openwins - 1
refreshwindows = true
switch = true
END SUB

FUNCTION window.create (X1, Y1, X2, Y2, closebtn, resizebtn, movebtn, title$)
IF Y2 = 5000 THEN Y1 = maxy / 2: Y2 = maxy '*little internal hack 4 shell :)
IF X2 > maxx THEN X2 = maxx
IF Y2 > maxy THEN Y2 = maxy
IF openwins = maxwins - 2 THEN SOUND 700, 1: SOUND 500, 1: EXIT FUNCTION
FOR i = 1 TO maxwins
 IF win(i).objectID = false THEN
  win(i).X1 = X1: win(i).X2 = X2
  win(i).Y1 = Y1: win(i).Y2 = Y2
  win(i).closebtn = closebtn
  win(i).resizebtn = resizebtn
  win(i).movebtn = movebtn
  win(i).title$ = title$
  FOR Z = 1 TO maxwins
   FOR x = 1 TO maxwins
    IF win(x).objectID = Z THEN GOTO n
   NEXT
   win(i).objectID = Z: EXIT FOR
n:
  NEXT
  openwins = openwins + 1
  refreshwindows = true
  repair = true
  window.create = Z: EXIT FUNCTION
 END IF
NEXT
window.create = false
END FUNCTION

SUB window.manager
MOUSESTATUS x%, y%, b%

IF b% <> false AND refreshwindows = false THEN
 'if mouse is in another window and pressed, set active
 FOR i = 1 TO maxwins
  IF win(i).objectID = false THEN i = i - 1: EXIT FOR
 NEXT
 IF x% >= win(i).X1 AND y% >= win(i).Y1 AND x% <= win(i).X2 AND y% <= win(i).Y2 THEN
  ELSE
  FOR Z = 1 TO openwins - 1
   IF x% >= win(Z).X1 AND y% >= win(Z).Y1 AND x% <= win(Z).X2 AND y% <= win(Z).Y2 THEN
    newactwin = Z    ' sets this for next routines below
   END IF
  NEXT
 END IF
END IF

IF newactwin <> false AND refreshwindows = false THEN
 ' set to new active window
 IF switch = true THEN
  MOUSEHIDE
  winvsave openwins
  MOUSESHOW
  FOR i = 1 TO maxwins
   IF win(i).objectID = false THEN EXIT FOR
  NEXT
  win(i).X1 = win(newactwin).X1: win(i).X2 = win(newactwin).X2
  win(i).Y1 = win(newactwin).Y1: win(i).Y2 = win(newactwin).Y2
  win(i).closebtn = win(newactwin).closebtn
  win(i).resizebtn = win(newactwin).resizebtn
  win(i).movebtn = win(newactwin).movebtn
  win(i).title$ = win(newactwin).title$
  win(i).virtual = win(newactwin).virtual
  win(i).objectID = win(newactwin).objectID
  FOR c = newactwin TO maxwins - 1  '*rollback routine*
   win(c).X1 = win(c + 1).X1: win(c).Y1 = win(c + 1).Y1
   win(c).X2 = win(c + 1).X2: win(c).Y2 = win(c + 1).Y2
   win(c).closebtn = win(c + 1).closebtn: win(c).resizebtn = win(c + 1).resizebtn
   win(c).movebtn = win(c + 1).movebtn: win(c).title$ = win(c + 1).title$
   win(c).virtual = win(c + 1).virtual: win(c).objectID = win(c + 1).objectID
  NEXT
  refreshwindows = true
 ELSE
  SOUND 700, .6 ' window switch = false so just beep..
  DO UNTIL b% = false
   MOUSESTATUS x%, y%, b%
  LOOP
 END IF
END IF

IF refreshwindows = true THEN  'refresh windows (duh)
 refreshwindows = false
 MOUSEHIDE
 hidegraph true
 dummy% = XMSBLKPUT%(1, 0, 0, bghandle%)
 FOR i = 1 TO maxwins
  IF win(i).objectID <> false THEN
   IF i = openwins THEN a% = true ELSE a% = false
   IF a% = true THEN
    IF crhandle% <> false THEN dummy% = XMSFREE%(crhandle%)
    crhandle% = XMSBLKGET%(0, 0, maxx, maxy)
   END IF
   window.paint win(i).X1, win(i).Y1, win(i).X2, win(i).Y2, win(i).closebtn, win(i).resizebtn, win(i).movebtn, win(i).title$, a%
   IF win(i).virtual <> false THEN
    Y1 = win(i).Y1: X1 = win(i).X1: Y2 = win(i).Y2: X2 = win(i).X2
    IF win(i).movebtn THEN Y1 = Y1 + 18
    IF win(i).resizebtn THEN X2 = X2 - 19: Y2 = Y2 - 19
    SETVIEW X1, Y1, X2 - 2, Y2 - 2
    winvput i  'put windows contents back into the window :)
    SETVIEW 0, 0, maxx, maxy
   END IF
  END IF
 NEXT
 hidegraph false
 MOUSESHOW
END IF

i = openwins
IF b% <> false AND refreshwindows = false THEN
 IF win(i).resizebtn <> false AND x% >= win(i).X2 - 19 AND y% >= win(i).Y2 - 19 AND x% <= win(i).X2 AND y% <= win(i).Y2 THEN
  xl = x% - win(i).X1: yl = y% - win(i).Y1
  SETVIEW win(i).X1, win(i).Y1, win(i).X2, win(i).Y2
  MOUSEHIDE
  winvsave i
  hidegraph true
  dummy% = XMSBLKPUT%(1, 0, 0, crhandle%)
  SETVIEW 0, 0, maxx, maxy
  DO
   MOUSESTATUS x%, y%, b%
   x3 = win(i).X1: y3 = win(i).Y1
   x4 = x% + (win(i).X2 - win(i).X1) - xl: y4 = y% + (win(i).Y2 - win(i).Y1) - yl
   IF x4 <= x3 + 70 THEN x4 = x3 + 70
   IF y4 <= y3 + 70 THEN y4 = y3 + 70
   IF x4 > maxx THEN x4 = maxx
   IF y4 > maxy THEN y4 = maxy
   handle2% = XMSBLKGET%(x3, y3, x4, y4)
   window.paint x3 + 0, y3 + 0, x4 + 0, y4 + 0, win(i).closebtn, true, win(i).movebtn, win(i).title, true
   drw3Dbox x4 - 19, y4 - 19, x4 - 2, y4 - 2, 0, actcolor + 0
   SETVIEW x3, y3, x4 - 21, y4 - 21
   winvput i
   SETVIEW 0, 0, maxx, maxy
   MOUSESTATUS xx%, yy%, bb%
   hidegraph false
   MOUSESHOW
   DO UNTIL x% <> xx% OR y% <> yy%
    MOUSESTATUS x%, y%, b%
    IF b% = false THEN s = true: GOTO e
   LOOP
   MOUSEHIDE
   hidegraph true
   dummy% = XMSBLKPUT%(1, x3, y3, handle2%)
e: 'Hidden deep inside your code you may find yourself
   dummy% = XMSFREE%(handle2%)
   IF s = true THEN EXIT DO
  LOOP
  MOUSESHOW
  refreshwindows = true
  win(i).X2 = x4: win(i).Y2 = y4
  repair = true
  MOUSEHIDE
  winvsave i
  MOUSESHOW
 END IF
 IF win(i).closebtn <> false THEN f = 20
 IF win(i).movebtn <> false AND x% >= win(i).X1 AND y% >= win(i).Y1 AND x% <= win(i).X2 - f AND y% <= win(i).Y1 + 18 THEN
  xl = x% - win(i).X1: yl = y% - win(i).Y1
  handle% = XMSBLKGET%(win(i).X1, win(i).Y1, win(i).X2, win(i).Y2)
  SETVIEW win(i).X1, win(i).Y1, win(i).X2, win(i).Y2
  MOUSEHIDE
  winvsave i
  hidegraph true
  dummy% = XMSBLKPUT%(1, 0, 0, crhandle%)
  SETVIEW 0, 0, maxx, maxy
  DO
   MOUSESTATUS x%, y%, b%
   x3 = x% - xl: y3 = y% - yl
   x4 = x% + (win(i).X2 - win(i).X1) - xl: y4 = y% + (win(i).Y2 - win(i).Y1) - yl
   IF x3 < 0 THEN x3 = 0: x4 = win(i).X2 - win(i).X1
   IF y3 < 0 THEN y3 = 0: y4 = win(i).Y2 - win(i).Y1
   IF x4 > maxx THEN x4 = maxx: x3 = x4 - (win(i).X2 - win(i).X1)
   IF y4 > maxy THEN y4 = maxy: y3 = y4 - (win(i).Y2 - win(i).Y1)
   handle2% = XMSBLKGET%(x3, y3, x4, y4)
   dummy% = XMSBLKPUT%(1, x3, y3, handle%)
   hidegraph false
   MOUSESTATUS xx%, yy%, bb%
   DO UNTIL x% <> xx% OR y% <> yy%
    MOUSESTATUS x%, y%, b%
    IF b% = false THEN s = true: GOTO E2
   LOOP
E2:
   hidegraph true
   dummy% = XMSBLKPUT%(1, x3, y3, handle2%)
   dummy% = XMSFREE%(handle2%)
   IF s = true THEN EXIT DO
  LOOP
  dummy% = XMSBLKPUT%(1, x3, y3, handle%)
  hidegraph false
  MOUSESHOW
  dummy% = XMSFREE%(handle%)
  win(i).X1 = x3: win(i).Y1 = y3: win(i).X2 = x4: win(i).Y2 = y4
  refreshwindows = true
 END IF
 IF win(i).closebtn <> false AND win(i).movebtn <> false AND x% >= win(i).X2 - 19 AND x% <= win(i).X2 - 2 AND y% >= win(i).Y1 + 2 AND y% <= win(i).Y1 + 18 THEN
  MOUSEHIDE
  DRWBOX 1, 0, win(i).X2 - 19, win(i).Y1 + 1, win(i).X2 - 1, win(i).Y1 + 18
  MOUSESHOW
  DO UNTIL b% = false
   MOUSESTATUS x%, y%, b%
  LOOP
  FOR R = 0 TO 1: t# = TIMER: DO UNTIL t# <> TIMER: LOOP: NEXT
  MOUSEHIDE
  DRWLINE 1, 15, win(i).X2 - 19, win(i).Y1 + 1, win(i).X2 - 19, win(i).Y1 + 17
  DRWLINE 1, 15, win(i).X2 - 19, win(i).Y1 + 1, win(i).X2 - 2, win(i).Y1 + 1
  MOUSESHOW
  IF x% >= win(i).X2 - 19 AND x% <= win(i).X2 - 2 AND y% >= win(i).Y1 + 2 AND y% <= win(i).Y1 + 18 THEN
   window.close i + 0
  END IF
 END IF
END IF
END SUB

SUB window.paint (X1%, Y1%, X2%, Y2%, closebtn%, resizebtn%, movebtn%, title$, active%)
'kenneths ripoff of the Amiga look >:)
DRWBOX 1, 0, X1%, Y1%, X2%, Y2%
DRWBOX 1, 0, X1%, Y1%, X2% - 1, Y2% - 1
DRWBOX 1, 15, X1% + 1, Y1% + 1, X2% - 2, Y2% - 2
IF LEFT$(title$, 1) <> CHR$(3) THEN
 DRWFILLBOX 1, 7, X1% + 2, Y1% + 2, X2% - 2, Y2% - 2
 ELSE
 title$ = MID$(title$, 2)
END IF
IF movebtn% THEN
 DRWLINE 1, 0, X1% + 1, Y1% + 18, X2% - 2, Y1% + 18
 DRWLINE 1, 15, X1% + 1, Y1% + 19, X2% - 2, Y1% + 19
END IF
IF active% THEN
 a = actcolor
 ELSE
 a = nonactcolor
END IF
IF movebtn% THEN
 DRWFILLBOX 1, a, X1% + 2, Y1% + 2, X2% - 2, Y1% + 17
 IF closebtn% THEN
  DRWLINE 1, 15, X2% - 19, Y1% + 2, X2% - 19, Y1% + 17
  DRWLINE 1, 0, X2% - 20, Y1% + 2, X2% - 20, Y1% + 17
  DRWBOX 1, 0, X2% - 13, Y1% + 7, X2% - 8, Y1% + 12
  DRWLINE 1, 15, X2% - 12, Y1% + 12, X2% - 8, Y1% + 12
  DRWLINE 1, 15, X2% - 8, Y1% + 8, X2% - 8, Y1% + 12
  b = 19
 END IF
 t$ = RTRIM$(title$)
 l% = ((X2% - X1%) / 2) - LEN(t$) * 4
 SETVIEW X1% + 2, Y1% + 3, X2% - 3 - b, Y1% + 17
 DRWSTRING 1, titlecolor, a, t$, X1% + 2 + l%, Y1% + 3
 SETVIEW 0, 0, maxx, maxy
END IF
IF resizebtn% THEN
 DRWFILLBOX 1, a, X2% - 18, Y2% - 18, X2% - 2, Y2% - 2
 DRWBOX 1, 0, X2% - 16, Y2% - 15, X2% - 12, Y2% - 11
 DRWBOX 1, 15, X2% - 16, Y2% - 15, X2% - 11, Y2% - 10
 DRWBOX 1, 0, X2% - 17, Y2% - 16, X2% - 5, Y2% - 5
 DRWBOX 1, 15, X2% - 16, Y2% - 15, X2% - 4, Y2% - 4
 DRWLINE 1, 15, X2% - 19, Y2% - 19, X2% - 19, Y2% - 2
 DRWLINE 1, 15, X2% - 19, Y2% - 19, X2% - 2, Y2% - 19
 DRWBOX 1, 0, X2% - 20, Y2% - 20, X2% - 1, Y2% - 1
 DRWLINE 1, 0, X2% - 20, Y1% + 20, X2% - 20, Y2% - 21
 DRWLINE 1, 0, X1% + 2, Y2% - 20, X2% - 21, Y2% - 20
 DRWFILLBOX 1, a, X2% - 19, Y1% + 20, X2% - 2, Y2% - 21
 DRWFILLBOX 1, a, X1% + 2, Y2% - 19, X2% - 21, Y2% - 2
END IF
END SUB

SUB winvput (id)
X1% = win(id).X1 + 2: Y1% = win(id).Y1% + 2
IF win(id).movebtn THEN
 Y1% = Y1% + 18
END IF
dummy% = XMSBLKPUT%(1, X1%, Y1%, win(id).virtual)
END SUB

SUB winvsave (id)
IF win(id).virtual <> false THEN dummy% = XMSFREE%(win(id).virtual)
X1% = win(id).X1 + 2: Y1% = win(id).Y1% + 2
X2% = win(id).X2 - 2: Y2% = win(id).Y2% - 2
IF win(id).movebtn THEN
 Y1% = Y1% + 18
END IF
IF win(id).resizebtn THEN
 X2% = X2% - 19
 Y2% = Y2% - 19
END IF
win(id).virtual = XMSBLKGET%(X1%, Y1%, X2%, Y2%)
END SUB

